
package org.odmg;
import java.util.List;

/**
* The interface that defines the operations of an ODMG array.
* Nearly all of its operations are defined by the JavaSoft <code>List</code> interface.
* All of the operations defined by the JavaSoft <code>List</code>
* interface are supported by an ODMG implementation of <code>DArray</code>,
* the exception <code>UnsupportedOperationException</code> is not thrown when a
* call is made to any of the <code>List</code> methods.
* An instance of a class implementing this interface can be obtained
* by calling the method <code>Implementation.newDArray</code>.
* @author	David Jordan (as Java Editor of the Object Data Management Group)
* @version ODMG 3.0
*/
// @see java.lang.UnsupportedOperationException

public interface DArray extends org.odmg.DCollection, java.util.List
{
/**
* Resize the array to have <code>newSize</code> elements.
* @param	newSize	The new size of the array.
*/
	public void resize(int newSize);
}

