// You can redistribute this software and/or modify it under the terms of
// the Ozone Library License version 1 published by ozone-db.org.
//
// The original code and portions created by SMB are
// Copyright (C) 1997-@year@ by SMB GmbH. All rights reserved.
//
// $Id: EnhDatabase.java,v 1.1 2002/05/08 15:03:21 per_nyfelt Exp $

package org.ozoneDB.odmg;

import java.util.*;
import org.odmg.*;


/**
 * This interface enhances the original ODMG {@link Database} interface by a
 * standard way to create persistent objects. Using this interface instead of
 * ODMG {@link Database} allows to keep the application code independent of the
 * actual underlying database. {@link OzoneODMGDatabase} implements this
 * interface already. All other databases need a wrapper that implements this
 * interface.
 * 
 * 
 * @author <a href="http://www.softwarebuero.de/">SMB</a>
 * @version $Revision: 1.1 $Date: 2002/05/08 15:03:21 $
 */
public interface EnhDatabase extends Database {
    
    
    /**
     * Create a new persistent instance of the given class. This method must be
     * executed in the context of an open transaction. If the transaction in
     * which this method is executed commits, then the object is made durable.
     * ClassNotPersistenceCapableException is thrown if the implementation
     * cannot make the object persistent because of the type of the object.
     */
    public Object createPersistent( Class cl );
    
}
