// You can redistribute this software and/or modify it under the terms of
// the Ozone Library License version 1 published by ozone-db.org.
//
// The original code and portions created by SMB are
// Copyright (C) 1997-2001 by SMB GmbH. All rights reserved.
//
// $Id: Client.java,v 1.1 2002/07/29 11:30:22 per_nyfelt Exp $

package test.odmg;

import java.io.*;
import org.odmg.*;
import org.ozoneDB.odmg.*;


public class Client {
    
    public static Implementation odmg;
    
    
    public static void main( String[] args ) throws Exception {
        odmg = new OzoneODMG();
        Database db = odmg.newDatabase();
        db.open( "ozonedb:remote://localhost:3333", Database.OPEN_READ_WRITE );
        
        Transaction tx = odmg.newTransaction();
        tx.begin();
        
        Auto auto = null;
        try {
            auto = (Auto)db.lookup( "name" );
        } catch (Exception e) {
            auto = new Auto( "Name" );
            System.out.println( auto.getClass().getSuperclass().getName() );
            System.out.println( Thread.currentThread().getName() + ": " + auto );
            db.bind( auto, "name" );
        } 
        
        auto.setName( "Trabant" );
        System.out.println( Thread.currentThread().getName() + ": " + auto );
        
        // db.deletePersistent (auto);
        
        tx.commit();
        
        db.close();
    } 
}
